﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;
using System.Collections.ObjectModel;
using System.ComponentModel;

namespace XamGridDateColumn
{
    /// <summary>
    /// Interaction logic for MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        private ObservableCollection<Person> col;
        public ObservableCollection<Person> Col
        {
            get { return col; }
            set 
            { 
                col = value;
                //NotifyPropertyChanged("Col");
            }
        }

        public MainWindow()
        {            
            InitializeComponent();
            Col = new ObservableCollection<Person>();
            Col.Add(new Person() { Name = "Johny", Age = 30, StartDate = DateTime.Now, EndDate = DateTime.Now.AddDays(1) });
            Col.Add(new Person() { Name = "Jim", Age = 40, StartDate = DateTime.Now, EndDate = DateTime.Now.AddDays(1) });
            Col.Add(new Person() { Name = "Jack", Age = 50, StartDate = DateTime.Now, EndDate = DateTime.Now.AddDays(1) });
            DataContext = this;
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }


        private void xamGrid1_CellExitingEditMode(object sender, Infragistics.Controls.Grids.ExitEditingCellEventArgs e)
        {
            if (e.Cell.Column.Key == "EndDate")
            {
                if ((e.Editor as DatePicker).SelectedDate < (DateTime)e.Cell.Row.Cells["StartDate"].Value )
                {
                    e.Cancel = true;
                    Dispatcher.BeginInvoke(new Action(() =>
                    {
                        (e.Editor as DatePicker).SelectedDate = (DateTime)e.Cell.Value;
                        (e.Editor as DatePicker).DisplayDate = (DateTime)e.Cell.Value;
                        e.Cell.IsActive = true;
                        e.Cell.IsSelected = true;
                    }));         

                }
            }
        }
    }

    public class Person : INotifyPropertyChanged
    {
        String name;

        public String Name
        {
            get { return name; }
            set
            {
                name = value;
                NotifyPropertyChanged("Name");
            }
        }
        int age;

        public int Age
        {
            get { return age; }
            set
            {
                age = value;
                NotifyPropertyChanged("Age");
            }
        }
        DateTime startDate;

        public DateTime StartDate
        {
            get { return startDate; }
            set
            {
                startDate = value;
                NotifyPropertyChanged("StartDate");
            }
        }

        DateTime endDate;

        public DateTime EndDate
        {
            get { return endDate; }
            set
            {
                endDate = value;
                NotifyPropertyChanged("EndDate");
            }
        }

        public event PropertyChangedEventHandler PropertyChanged;

        private void NotifyPropertyChanged(String info)
        {
            if (PropertyChanged != null)
            {
                PropertyChanged(this, new PropertyChangedEventArgs(info));
            }
        }
    }
}
